//+------------------------------------------------------------------+
//|                                                  lesson10_EA.mq4 |
//|                        Copyright 2021, chart.view Software Corp. |
//|                            https://www.instagram.com/chart.view/ |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, chart.view Software Corp."
#property link      "https://www.instagram.com/chart.view/"
#property version   "1.00"
#property strict

double ma_10[];
double rsi_14[];
double cci_21[];
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
//   ArrayResize(ma_10,100);
//   ArrayResize(rsi_14,100);
//   ArrayResize(cci_21,100);
//   
//   ReadFile();
//   
//   Comment("ma_10[0] : ",ma_10[1],"\nrsi_14[0] : ",rsi_14[1],"\ncci_21[0] : ",cci_21[1]);
   
   
   write_file();
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ReadFile()
{
   string file_name = "data.csv";
   int file_handle = FileOpen(file_name,FILE_READ|FILE_CSV,',',CP_UTF8);
   
   if(file_handle != INVALID_HANDLE)
   {
      int row = 0 , col = 0;
      
      while(!FileIsEnding(file_handle))
      {
         string cell = FileReadString(file_handle);
         
         if(col == 0)
            ma_10[row] = StrToDouble(cell);
         else if(col == 1)
            rsi_14[row] = StrToDouble(cell);
         else if(col == 2)
            cci_21[row] = StrToDouble(cell);
            
         if(FileIsLineEnding(file_handle))
         {
            col = 0;
            row++;
         }
         else
         {
            col++;
         }   
           
      }
      FileClose(file_handle);  
   }
   else
      Print("failed to open "+file_name+" due to : ",GetLastError());
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void write_file()
{
   string file_name = "indicator_data.csv";
   int file_handle = FileOpen(file_name,FILE_READ|FILE_WRITE|FILE_CSV|FILE_ANSI,',');
   
   if(file_handle != INVALID_HANDLE)
   {
      FileSeek(file_handle,0,SEEK_END);
      
      for(int i=1;i<=20;i++)
      {
         double ma_10 = NormalizeDouble(iMA(_Symbol,PERIOD_CURRENT,10,0,MODE_SMA,PRICE_CLOSE,i),_Digits);
         double rsi_14 = NormalizeDouble(iRSI(_Symbol,PERIOD_CURRENT,14,PRICE_CLOSE,i),_Digits);
         double cci_21 = NormalizeDouble(iCCI(_Symbol,PERIOD_CURRENT,21,PRICE_CLOSE,i),_Digits);
         
         FileWrite(file_handle,"time",Time[i],"ma_10",ma_10,"rsi_14",rsi_14,"cci_21",cci_21);
         
      }
      
      FileClose(file_handle);
      
   }
}